/***********************
 Url builder 2.1
 params: 
		el		 	-> HTML object.
		urlFlag 	-> Bool - Has the URL been changed previously.
		options		-> {}	
 Simon Ilett
 Created 07/10/2010
**********************/

function urlBuilder(el, urlFlag, options) {
	
	var defaults = {
		title : {
			regx	: [/[^0-9a-zA-Z\s.,'!@%#)(:\;\"]+?/,/\s+/g,/^[\s]+/g,/([0-9a-zA-Z\s.,'!@%#)(:\;\"]{30})(.+)/i],
			rep		: ['',' ','', '$1']
		},
		url : {
			regx	: [/[^0-9a-zA-Z]+?/g,/[\-]+/g,/^[-]+/,/[-]+$/],
			rep		: ['-','-','','-']
		}
	}
	
	this.options 	= jQuery.extend(defaults, options);
	
	this.init = function(el, urlFlag) {
		var id 			= el;
		this.inputObj 	= $('#'+el); 	
		this.newUrl		= $('#'+id+'_url');
		this.updateUrl	= $('#'+id+'_update');
		this.edit		= $('#'+id+'_edit');
		this.ChangedURL = (!urlFlag ? false : urlFlag);
		this.events();
    };

	this.events = function() {	
		var obj = this;
		this.inputObj.bind('keyup', function(e) {					 
		  	obj.loadUri(e, 'title');
		});
		this.newUrl.bind('keyup', function(e) {		 
		  	obj.loadUri(e, 'url');
		});
		this.edit.bind('mousedown', function(e) {
			e.preventDefault();						 
		  	obj.showURL(e.target);
		});
	};
	
	this.loadUri = function(e, str) {
		e.preventDefault();					
		this.getValue(e.target, this.options[str]);
	};
	
	this.getUri = function(uri, o) {
		var collection = o.regx;
		for (index in collection) {
			uri = uri.replace(collection[index], o.rep[index]);
		}	
		return uri;
	};
	
	this.getValue = function(e, o) {
		var input = $(e);
		if (input[0] == this.newUrl[0]) this.ChangedURL=true;
		var tmp = this.getUri(input.attr('value'), o);
		input.attr('value', tmp);
		if (input[0] != this.inputObj[0] || !this.ChangedURL) {
			tmp = this.getUri(tmp, this.options.url);
			//this.newUrl.value = tmp.toLowerCase();
			this.newUrl.attr('value', tmp.toLowerCase());
			this.update(tmp + (tmp != '' ? '/' : ''));
		}
	};
	
	this.showURL = function(e) {
		var o = this.newUrl;
		var u = this.updateUrl;
		if (o.css('display') == 'none') { 
			o.css('display', 'inline-block');
			u.css('display', 'none');
			this.edit.html('save');
		} else { 
			o.css('display', 'none');
			u.css('display', '');
			this.edit.html('edit');
		}
	};
	
	this.update = function(s) {
		this.updateUrl.html(s);
	};
	
    this.init(el, urlFlag);
	
}

