/***********************
 Url builder 2.1
 params: 
		element 	-> HTML object.
		urlFlag 	-> Bool - Has the URL been changed previously.
		options		-> {}	
 Simon Ilett
 Created 15/06/2009
**********************/

var urlBuilder = new Class({

	Implements: [Options, Events],
	
	options: {
		defaultValue : '',
		defaultError : 'Invalid characters in your title',
		title : {
			regx	: [/[^0-9a-zA-Z\s.,'!@%#)(:\;\"]+?/,/\s+/g,/^[\s]+/g,/([0-9a-zA-Z\s.,'!@%#)(:\;\"]{50})(.+)/i],
			rep		: ['',' ','', '$1']
		},
		url : {
			regx	: [/[^0-9a-zA-Z]+?/g,/[\-]+/g,/^[-]+/,/[-]+$/],
			rep		: ['-','-','','-']
		}
	},
	
	initialize: function(element, urlFlag, options){
		this.setOptions(options);
		this.inputObj 	= element;
		this.newUrl		= $(element.id+'_url');
		this.updateUrl	= $(element.id+'_update');
		this.edit		= $(element.id+'_edit');
		this.ChangedURL = (!urlFlag ? false : urlFlag);
		this.init();
	},
	
	init: function() {
		this.inputObj.addEvent('keydown', this.getValue.bindWithEvent(this,  this.options.title ));
		this.inputObj.addEvent('keyup', this.getValue.bindWithEvent(this,  this.options.title ));
		this.newUrl.addEvent('keyup', this.getValue.bindWithEvent(this, this.options.url));
		this.edit.addEvent('mousedown', this.showURL.bindWithEvent(this));
	},
	
	
	getUri: function(uri, o) {
		o.regx.each(function(index, key) {		
			uri = uri.replace(index, o.rep[key]);
		});
		return uri;
	},
	
	getValue: function(e, o) {
		var input = getTarget(e);
		if (input == this.newUrl) this.ChangedURL=true;
		
		var tmp = this.getUri(input.value, o);
		
		if (input.value != tmp )
			input.value = tmp;
		
		if (input != this.inputObj || !this.ChangedURL) {
			tmp = this.getUri(tmp, this.options.url);
			this.newUrl.value = tmp.toLowerCase();
			this.update(tmp + (tmp != '' ? '/' : ''));
		}
	},
	
	showURL: function(e) {
		var o = this.newUrl;
		var u = this.updateUrl;
		if (o.getStyle('display') == 'none') { 
			o.setStyle('display', 'inline-block');
			u.setStyle('display', 'none');
			this.edit.set('html', 'Save');
		} else { 
			o.setStyle('display', 'none');
			u.setStyle('display', '');
			this.edit.set('html', 'edit');
		}
	},
	
	update: function(s) {
		this.updateUrl.set('html', s);
	}
	
});



/*************************/
/* target grabber       */
/* Author: Simon Ilett */ 
/**********************/
function getTarget(e){
	if (typeof(e)=='object') {
		var evt = new Event(e); 
		var target = $(evt.target);	
	} else {
		var target = $(e);	
	}
	return (target ? target : false);
}


